//Craneplus.h
#ifndef __Craneplus_H__
#define __Craneplus_H__

//w萔̎gp
#define _USE_MATH_DEFINES

/********* includet@C *********/
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream>

#ifdef _WIN32
#include "SerialCommunication.h"

#else
//linux******************
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
//*******************

#endif


/********* L萔 *********/

// A[Rx (CRANE+ has 5 freedom)
#define ARM_FREEDOM	5

// A[̃N̒
#define r1      83
#define r2      93.5
#define r3      138

//1[^̉͈
#define	Angle1_LimitMax	300
#define	Angle1_LimitMin	0
//2[^̉͈
#define	Angle2_LimitMax	300
#define	Angle2_LimitMin 0
//3[^̉͈
#define	Angle3_LimitMax	300
#define	Angle3_LimitMin	0
//4[^̉͈
#define	Angle4_LimitMax	300
#define	Angle4_LimitMin	0
//5[^̉͈

//X͈[mm]
#define X_LimitMax   329
#define X_LimitMin   -300
//Y͈[mm]
#define Y_LimitMax   314.5
#define Y_LimitMin   -314.5
//Z͈[mm]
#define Z_LimitMax   359.9
#define Z_LimitMin   0

//nh̉͈
#define Hand_LimitMax	   130
#define Hand_LimitMin	   185


/********* L萔̏I *********/



/********* Type define *********/

typedef unsigned char uchar;

//T[{ɏރf[^
typedef struct
{
  int CW_ComplianceMargin;
  int CCW_ComplianceMargin;
  
  int CW_ComplianceSlope;
  int CCW_ComplianceSlope;
  
  double Angle;	//degree
  double Speed;	//rpm
  double Torque;//%
}ServoWrite;

//CRANẼWCg~bg̍\
typedef struct
{
  short Upper;
  short Lower;
}JLimit;

//CRANẺ͈̓~bg̍\
typedef struct
{
  short Upper;
  short Lower;
}CLimit;

typedef struct
{
  CLimit x;
  CLimit y;
  CLimit z;
}Cartesian;

/********* END Type define *********/



/******************NX`*********************/ 
class Craneplus{
 private:

  //privateϐ̐錾
  char *dev;
  ServoWrite Writedata[ARM_FREEDOM]; //Writedata[0]̓T[{ID1̃f[^
  double ReadAngle[ARM_FREEDOM];
  Cartesian CRANECartesianLimit;
  JLimit CRANEJointLimit[5];
#ifdef WIN32
  SerialCommunication sc;
#else
  int fd;
  struct termios newtio;
#endif
  //private֐̒`
  //VAʐM֐

  //VAʐMŃf[^𑗐M
  void serialWrite(uchar *buf, int length);

  //VAʐMŃf[^M
  void serialRead(uchar *buf, int length);

  //VAʐMp̃`FbNTvZ
  uchar calcCheckSum(uchar *buf, int Datasize);

  //VAʐMłĂ邩mF
  void checkserial();

  //DynamixelRegWriteŃf[^𑗐M
  void RegWrite(int id, ServoWrite data[]);

  //DynamixelActionŃf[^𑗐M
  void Action(void);

  //T[{Anglel󂯎
  void ReadServoAngle(int id, double ReadAngle[]);

  //A[̊e֐߂Anglel󂯎
  void ReadArmAngle();
public:

  //RXgN^
  Craneplus();

  //VAʐM֐
  //VAʐMJn
  int OpenCOMDevice(const char *SERIAL_PORT);

  //VAʐMI
  void CloseCOMDevice();
  

  // ֐
  //T[{[^[ɑf[^̕ϐ֐

  void initServo(int id, ServoWrite data[]);
  //ׂẴT[{[^[ɑf[^̕ϐ֐

  void initArm();

  //privateϐZbg֐
  //JointPos[]̒lWritedata[].Angleɏ
  void setCRANEJointdata(double JointPos[]);

  //spdRatio̒lWritedata[].Speedɏ
  void setCRANESpeeddata(int id, double spdRatio);

  //CartesianLimit̒lCRANECartesianLimitɏ
  void setCRANECartesianLimit(Cartesian CartesianLimit);

  //JointLimit[]̒lCRANEJointLimit[]ɏ
  void setCRANEJointLimit(JLimit JointLimit[]);


  //privateϐQbg֐
  //NX̕ϐ̊pxf[^肷
  void getCRANEJointdata(double JointPos[]);

  //NX̕ϐ̑xf[^肷
  void getCRANESpeeddata(double spdRatio);

  //NX̕ϐ͈̔̓~bgf[^肷
  void getCRANECartesianLimit(Cartesian CartesianLimit);

  //NX̕ϐ͈̔̓~bgf[^肷
  void getCRANEJointLimit(JLimit JointLimit[]);

  
  // CRANE+Ɋւ֐
  //DynamixelWrite_DataŃT[{[^[̃gNOnOff
  void ServoOnOff(int torque);

  //DynamixelRegWrite-ActionWritedata[]ɏ܂ꂽf[^DynamixelɑM
  void ArmAction();

  //CRANẼnh
  void CRANEcloseGripper();

  //CRANẼnhJ
  void CRANEopenGripper();

  //CRANẼnhw肵JxłJ
  void CRANEmoveGripper(double angleRatio);

  //Catesian\tg~bg̔s
  int CartesianLimitJudgement( double x , double y , double z );

  //Joint\tg~bg̔s
  int JointLimitJudgement();

  //CRANE+~bg̔s
  int CRANELimitJudgement(double x, double y, double z);

  //A[̋t^wvZ
  void kinematics(double x, double y, double z, double JointPos[]);



/********* ֐̃vg^Cv錾̏I *********/
 
};

/**************** extern 錾 *****************/
extern Craneplus crane;

#endif//__Craneplus_H__
